<script lang="ts">
	import { HostingType, type MatrixServiceInterface } from "../types";
	import PriceLabel from "../ui/PriceLabel.svelte";
	import ServerNotPowerfulBadge from "../ui/ServerNotPowerfulBadge.svelte";
	import { isServerEnoughForComponent } from "../utils";
	import { entityStore } from "../utils/entityStore";

	export let additionalServices: Partial<MatrixServiceInterface>[];
	export let selectedServices: Partial<MatrixServiceInterface>[];

	let additionalServicesToUse = JSON.parse(JSON.stringify(additionalServices));

	$: if ($entityStore) {
		// reset this section
		if ($entityStore.hostingType !== HostingType.BYOS) {
			selectedServices = selectedServices.filter((service) => {
				return isServerEnoughForComponent(service, $entityStore);
			});
		}
	}
</script>

<div class="row">
	<div class="col-md-12 mb-2">
		{#each additionalServicesToUse as additionalService, additionalServiceIdx}
			{@const serverIsEnoughForComponent = isServerEnoughForComponent(additionalService, $entityStore)}
			{@const componentIsSelected = selectedServices.find((current) => current.id === additionalService.id)}
			{#if !additionalService.archived}
			<div class="d-flex flex-row mb-1 justify-content-between align-items-center">
				<div class="d-flex align-items-center flex-grow-1">
					<span class="form-check form-switch d-inline-block align-self-start">
						<input
							id={"service-" + additionalService.id}
							class="form-check-input"
							type="checkbox"
							disabled={!serverIsEnoughForComponent}
							bind:group={selectedServices}
							name={"additional-service-" + additionalService.id}
							value={additionalService}
						/>
					</span>
					<div class="d-flex flex-column flex-grow-1">
						<label for={"service-" + additionalService.id} class="px-2">
							<span class="d-inline-block">{additionalService.name}</span>
							<br />
							<span class="text text-muted">{additionalService.description}</span>
						</label>
					</div>
					<div class="d-flex flex-column flex-md-row">
						<a href={additionalService.help} target="_blank" rel="noreferrer"><span class="d-inline badge rounded-pill text-primary btn btn-outline-warning">more details</span></a>
						<div class="ms-2 mt-3 my-md-0 d-block d-lg-inline-block"><PriceLabel price={additionalService.price} /></div>
					</div>
				</div>
			</div>

			{#if componentIsSelected && additionalService.additionalFields}
				<div class="mt-3">
					{#if additionalService.helpText}
						<p>
							{@html additionalService.helpText}
						</p>
					{/if}

					{#each additionalService.additionalFields as serviceAdditionalField}
						<label
							class="mb-1"
							for={"serviceAdditionalFied-" + serviceAdditionalField.id}
						>
							{serviceAdditionalField.name}
							{#if serviceAdditionalField.required}
								<span class="text-danger fs-4">*</span>
							{/if}
						</label>
						<input
							class="form-control mb-2"
							type="text"
							id={"serviceAdditionalFied-" + serviceAdditionalField.id}
							name={"serviceAdditionalFied-" + serviceAdditionalField.id}
							placeholder={serviceAdditionalField.placeholder}
							pattern={serviceAdditionalField.pattern}
							required={serviceAdditionalField.required}
							bind:value={serviceAdditionalField.value}
						/>

						{#if serviceAdditionalField.tooltip}
							<p class="text-muted mb-1">
								{@html serviceAdditionalField.tooltip}
							</p>
						{/if}
					{/each}
				</div>
			{/if}
			<ServerNotPowerfulBadge serverIsPowerful={serverIsEnoughForComponent} />

			{#if additionalServiceIdx !== additionalServices.length - 1}
			<hr />
			{/if}

			{/if}
		{/each}
	</div>
</div>
